Unit Main;
// Objet : Conversion de Nombres en leur expression littrale franaise
// Auteur : P.Angst (Delphi-fan) , d'aprs un source -largement corrig,
//    comment et enrichi- , d semble-t-il  J.Jamet .
// But : pdagogique.
// Documentation : P.Constantine, A.Chambily et P.Angst
// Mthode : ITERATIVE
// Date : v1.0 du 10/10/03

interface

uses Windows, SysUtils, Classes, Controls, Forms, StdCtrls, Buttons,
  ExtCtrls ;

type
   TMainForm = class(TForm)
    InputEdit: TEdit;
    ResultEdit: TEdit;
    ClearBtn: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Bevel1: TBevel;
    GoBtn: TBitBtn;
    DecimChkBox: TCheckBox;
    InfoBtn: TBitBtn;
    MajChkBox: TCheckBox;
    DecimGroup: TRadioGroup;
    GoLabel: TLabel;
    ClearLabel: TLabel;
    Label5: TLabel;
    QuitBtn: TBitBtn;
    IntGroup: TRadioGroup;
    procedure ClearBtnClick(Sender: TObject);
    procedure GoBtnClick(Sender: TObject);
    procedure InputEditKeyPress(Sender: TObject; var Key: Char);
    procedure InfoBtnClick(Sender: TObject);
    procedure DecimChkBoxClick(Sender: TObject);
   private
     { Dclarations Prives }
   public
     { Dclarations Publiques}
   end;

var
  MainForm: TMainForm;
  Function NbEnLettres(N:int64):String;

implementation

 {$R *.dfm}

{-------------------------------------------------------------------}
Function NbEnLettres(N:int64):String;  // NB : nombres positifs
Const
  Unites : Array[1..16] of String=('un','deux','trois','quatre','cinq','six',
                              'sept', 'huit', 'neuf', 'dix', 'onze', 'douze',
                              'treize', 'quatorze', 'quinze', 'seize');
  Dizaines : Array[2..8]of String=('vingt', 'trente', 'quarante', 'cinquante',
                              'soixante','','quatre-vingt');
  Centaine = 'cent';     // pour bien voir la logique uniquement...
  PuissancesDeMille : Array[1..3] of String= ('mille', 'million', 'milliard');
Var
  Temp  : String; // variable temporaire pour construire la chane...
  U,D,C : byte;   // Coef Units , Dizaines , Centaines  chaque itration
  Ordre : Byte;   // Nb d'itrations : ordre de grandeur (en puissances de 1000)
  // autrement dit, c'est le nombre de sparateurs de milliers
  //ex 1 : 150.300 -> coef = 1   ;  ex 2 : 3.200.000 -> coef = 2
  M    : integer;   // coef des puissances de 1000
  // ex 1 -> M= 150  ; ex 2 -> M= 3200 (avec coef=1) ou M=3 (avec coef=2)
Begin
  Result:='';  // va stocker les rsultats partiels  venir.
  Ordre:= 0;   // reprsente le nombre d'itrations par groupe de 3 chiffres !
  M := 0;

  If N=0 then  // Inutile de traiter le cas du 0
  Begin
    Result:='zro';   // on a enlev l'accent
    Exit;
  End;

  REPEAT
    // rappel : la fonction div renvoie la partie entire de la division
    // ... et mod donne le reste de cette division.
    U:= N mod 10; // Rcupre units pour l'itration en cours
    N:= N div 10;
    D:= N mod 10; // Rcupre dizaines...
    N:= N div 10; // ... aprs on s'intressera au reste ventuel ...

 { 1- Analyse des Dizaines ...  }

    // pr-traite les cas particuliers des dizaines
    // et les considre comme des "units"
    If D in [1,7,9] then
    Begin
      Dec(D);         // Ex : 76 -> 60 + 16
      Inc(U,10);      // Ex : 16 = 1x10 + 6 -> 0x10 + 16
    End;

    Temp:='';
    If D>1 then // la dizaine sera traite comme cas particulier des Units...
    Begin
      Temp:= Dizaines[D];
      if (D=2) and (U<>1) Then Temp := Temp + '-';   // ex : 25
      if (D=8) and (U>0) and (U<10) Then Temp := Temp + '-';   // 81 - 89
      If (D<8) and ((U=1) or (U=11)) then   // Ex : 21, 71 .
       Temp:=Temp+' et';
    End;

 { 2- Analyse des "Units" ...  }

   // Units "composes" (exceptions du franais au systme dcimal)
    If U>16 then  // dizaines = 1, 7 ou 9 (cf point 1)
    Begin     // Exemple : 77 -> 60 + 17
       // Cas : 77 - 79  et  97 - 99 -> gestion des traits d'union
      if ((D=6) or (D=8)) then Temp := Temp + '-' + Unites[10] + '-' 
       // Cas : 17 - 19
       else Temp := Temp + Unites[10];  // on rajoute le terme 'dix'
      Dec(U,10); // Ex : 17 - 10 (cf 'dix' ci-dessus) = 7
      // -> on va ensuite traiter ce chiffre comme une unit ordinaire...
    End;

   // Units "simples" (aprs traitement ventuel des exceptions ci-dessus)
    If U>0 then
    begin
     // ajoute espace entre les mots si l'on vient d'valuer un terme
     // et que l'on n'a pas dj rajout un trait d'union
      if temp <> '' then   // ex : 33 -> 'trente' + ' ' + 'trois'
       if (Temp[length(temp)]<>'-') then temp := temp + ' ';
      Temp := Temp + Unites[U];  // ex 83 -> 'quatre-vingt-' + 'trois'
    end;
    // marque du pluriel si le nombre intial se termine par 80
    If (result='') and (D=8) and (U=0) then temp := temp + 's';  // ..80
    // si ce n'est pas le dernier terme de la phrase ( droite) et si l'on a
    // dans la boucle en cours une unit ou dizaine -> on spare les termes
    if (result <> '') and (temp <> '') then temp := temp + ' ';
    Result:= Temp + Result;

 { 3- Les Centaines ...  }

    C:=N mod 10;   // dernier chiffre du coef des centaines en cours
    N:=N div 10;   // -> chiffres en 3 position  partir Droite minimum
    If C>0 then    // > 0 ?
    Begin
      Temp:='';
      If C>1 then   //  si C=1 , => 1x100 => 'un cent' est incorrect ...
        Temp:= Unites[C] + ' ';
      Temp:= Temp + centaine;    //  + 'cent'  la chane
      if (result <> '') then Temp := Temp + ' '; // espace avant le reste  droite
     // aprs 'cent', accord pluriel ventuel si dernier terme
      If (Result='') and (C>1) then Result:='s';  // Ex : 700 -> ..'cents'
      Result:= Temp + Result;
    End;

 { 4- Les Milliers, Millions, etc ...  }

    If N>0 then  // Il reste qq chose aprs limination des centaines ?
    Begin
      Temp := '';
      Inc(Ordre);   // on considre les sparateurs de milliers ventuels
      M:= N mod 1000;  // ... et on teste leur existence -> coef !
      if M>0 then
      begin
        Temp := PuissancesDeMille[Ordre];
        if (M=1) and (Ordre=1) then Dec(N);  // 1000-1999 -> N=0 Fin aprs.
      // 'mille' invariable mais au del (million..), le pluriel existe ...
        if (M>1) and (Ordre>1) then Temp:= Temp + 's';
      // multiples de 1000 : 'mille' est le dernier terme -> pas ' ' aprs
        if Result <> '' then Temp := Temp + ' ';
        Result := Temp + Result;
      end;
    End;    // on va recommencer la boucle avec notre rsultat partiel...
  UNTIL N=0;
End;

{-----------------------------------------------------}
procedure TMainForm.ClearBtnClick(Sender: TObject);
begin  // efface les zones de saisie
  ResultEdit.Text := '';
  InputEdit.Text := '';
end;

{-------------------------------------------------}
procedure TMainForm.GoBtnClick(Sender: TObject);
var tmp : extended;
    chaine : string;  // resultat en lettres
    saisie, entier, decim : string;  // parties du nombre
    p : byte;   // position sparateur dcimal -> spare Entier/Decimal
begin
  // initialisations
  tmp := 0;
  chaine := '';
  entier := '' ; decim := '';
  saisie := InputEdit.Text;
  if saisie <> '' then
  begin
 { (a) On traite le cas des nombres ngatifs  part   }
    // NB : la conversion d'un nombre tel que -.015 pose problme...
    // pour la partie entire : strtofloat(-0) -> 0 : on perd le signe !
    if saisie[1] = '-' then   // ngatif ?
    begin
      chaine := 'moins ';  // on ne va valuer que des nombres positifs
      delete(saisie,1,1);  // ...donc on supprime le '-'
    end;

 { (b) On vrifie que la saisie donne un rel acceptable ... }
    try
      tmp := StrToFloat(saisie);  // rel ?
    except
      on E:EConvertError do
      begin
        Application.MessageBox('Nombre incorrect !' , 'Erreur de saisie',
         MB_IconWarning + MB_OK);
        exit;
      end;
    end;

 { (c) nombre correct : on va d'abord lancer la fonction pour la partie entire }
   // NB : par la suite on ne va pas utiliser les fonctions Trunc, Int et Frac
   // car Frac est peu prcise (renvoie 0.xxxx -> nb decim = ???) et car les
   // rels sont arrondis  partir d'un certain nombre de dcimales ...
    p := pos('.', saisie) + pos(',', saisie);
    // NB : seul le sparateur dcimal actif (cf param. rgionaux) est valu
    // .. l'autre donne 0 mais est cart par l'tape prcedente .
    if p=0 then entier := saisie    // pas de dcimales
     else entier := (copy(saisie,1,p-1));  // on s'arrte au sparateur ...
    chaine := chaine + NbEnLettres(strtoint64(entier));

 { (d) Rajout de la mention optionnelle 'euro(s)' pour les nb entiers ?   }
    if (IntGroup.Enabled = true) and (IntGroup.ItemIndex = 1) then  // oui
    begin
      chaine := chaine + ' euro';
      if strtoint64(entier) > 1 then chaine := chaine + 's';
    end;

 { (e) Veut-on traiter les dcimales ?   }
    if decimChkbox.Checked = true  //  <=> DecimGroup.enabled = true !
    then
    begin
      // extrait les caractres aprs le sparateur dcimal
      decim := copy(saisie, p+1, length(saisie)-p);
      // Dcimales utiles ? (ex :  '125'  ,  '125.' , '125.0' )
      if not ((p=0) or (decim = '') or (strtoint64(decim) = 0) )
       then  // Oui : on relance la fonction pour les dcimales
      begin
        case DecimGroup.ItemIndex of
         0: chaine := chaine + ' virgule ' + NbEnLettres(strtoint64(decim));
         1: begin
              chaine := chaine + ' virgule '
                + NbEnLettres(strtoint64(decim)) + ' euro';
              if strtoint64(entier) > 1 then chaine := chaine + 's';
            end;
         2: begin
              chaine := chaine + ' euro';
              if strtoint64(entier) > 1 then chaine := chaine + 's';
              chaine := chaine + ' et '
                + NbEnLettres(strtoint64(decim)) + ' centime';
              if strtoint64(decim) > 1 then chaine := chaine + 's';
            end;
        end; // ..case
      end;  // .. dcimales utiles ?
    end; // {e}

 { (f) caractres minuscules ou majuscules ?   }
    if MajChkbox.Checked = true  //  oui :
     then chaine := AnsiUpperCase(chaine);

    ResultEdit.Text := chaine;  // affiche rsultat final
  end;
end;

{--------------------------------------------------------------------}
procedure TMainForm.InputEditKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then GoBtnclick(sender);
  if (key <> '.') and (key <> ',') and (key <> '-') and (key <> #08) then
   If Not(Key in ['0'..'9']) Then Key := #0;
end;

{-----------------------------------------------------}
procedure TMainForm.InfoBtnClick(Sender: TObject);
begin
  Application.MessageBox('Programme et documentation raliss  titre'
   + ' ducatif par :'+ #13 + 'P.Constantine, A.Chambily et P.Angst '
   + 'd''aprs un source original de J.Jamet', 'Copyright',MB_OK);
end;

{-----------------------------------------------------}
procedure TMainForm.DecimChkBoxClick(Sender: TObject);
begin
  if DecimChkBox.Checked = false then
  begin  // active Options des Entiers
    DecimGroup.Enabled := false;
    IntGroup.Enabled := true;
  end
  else   // active Options dcimales
  begin
    DecimGroup.Enabled := true;
    IntGroup.Enabled := false;
  end;
end;

end.
(*
====== A N N E X E  : les accords de l'orthographe franaise =============

VINGT
1 L'adjectif numral prend la marque du pluriel s'il est multipli par un nombre
et s'il n'est pas suivi d'un autre adjectif de nombre. Quatre-vingts feuilles,
quatre-vingt-huit francs. Attention aux mots million, milliard qui ne sont pas
des adjectifs numraux, mais des noms. Quatre-vingts millions. Prcd de cent
ou de mille, l'adjectif numral est toujours invariable. Cent vingt personnes.
2 Dans les adjectifs numraux composs, le trait d'union s'emploie seulement
entre les lments qui sont l'un et l'autre infrieurs  cent, sauf si ces
lments sont joints par la conjonction et. Cent quatre-vingts. Vingt et un. Vingt-cinq.

QUATRE-VINGT(s) adj. et n. m.  Adjectif numral cardinal. Quatre fois vingt.
Il a quatre-vingts ans, elle a quatre-vingt-deux ans.
Note.- L'adjectif numral cardinal s'crit avec un s s'il est multipli par un
nombre et s'il n'est pas suivi d'un autre adjectif numral.
 Adjectif numral ordinal invariable. Quatre-vingtime. La page quatre-vingt.
En mil neuf cent quatre-vingt.
Note.- L'adjectif ordinal est invariable.
 Nom masculin invariable. Des quatre-vingt en lettres lumineuses.
Notes.-
1 Attention aux nombres composs des mots million, milliard qui ne sont pas des
 adjectifs numraux, mais des noms et qui permettent donc la marque du pluriel
  vingt si l'adjectif numral est multipli par un nombre. Quatre-vingts millions
  de francs.
2 Aprs l'adjectif numral, la conjonction et ne s'emploie pas devant un , contrairement
 trente et un, quarante et un... Quatre-vingt-un citrons, quatre-vingt-une tomates.
3 Les adjectifs numraux composs de quatre-vingt s'crivent avec des traits
 d'union. Quatre-vingt-deux, quatre-vingt-trois, quatre-vingt-dix,
 quatre-vingt-onze, quatre-vingt-dix-sept.

CENT adj. num. et n. m. Adjectif numral cardinal
- L'adjectif cent prend un s quand il est multipli par un autre nombre et qu'il
termine l'adjectif numral. J'ai lu sept cents pages.
- Il est invariable quand il n'est pas multipli par un autre nombre (il a lu
 cent pages) et qu'il est suivi d'un autre nombre (elle a crit trois cent
 vingt-sept pages).
- Devant millier, million, milliard , l'adjectif cent s'accorde quand il n'est
pas suivi d'un nom de nombre. Quatre cents millions de francs.

MILLE adj. inv. et n. m. inv.  Adjectif numral invariable.

MILLION n. m.  Symbole M (s'crit sans point).
 Mille fois mille. Le total s'lve  quinze millions de francs.

*)

